#!/bin/bash

CONFIG_NAME="registrymodifications.xcu"
CONFIG_PATH="$HOME/.config/libreoffice/4/user/"
CONFIG_FILE="$HOME/.config/libreoffice/4/user/$CONFIG_NAME"
PATTERN_START="<item oor:path=\"/org.openoffice.Office.Common/Misc\"><prop oor:name=\"SymbolStyle\" oor:op=\"fuse\"><value>"
PATTERN_END="</value></prop></item>"
FILE_END="</oor:items>"

if [ -f "$CONFIG_FILE" ]; then
 grep "$PATTERN_START" "$CONFIG_FILE"
 if [ $? != 0 ]; then
#  sed -i "#${FILE_END}#d" "$CONFIG_FILE"
   sed -i '$d' "$CONFIG_FILE"
   echo "${PATTERN_START}$1${PATTERN_END}" >> "$CONFIG_FILE"
   echo "$FILE_END" >> "$CONFIG_FILE"
   echo add SymbolStyle to libreoffice config $HOME/.config/libreoffice/4/user/registrymodifications.xcu
   exit
 fi

 ICON_THEME_OLD=
 ICON_THEME_NEW=
 if [ "$1" == "breeze" ]; then
   ICON_THEME_NEW="breeze"
   ICON_THEME_OLD="breeze_dark"
 else
   if [ "$1" == "breeze_dark" ]; then
     ICON_THEME_NEW="breeze_dark"
     ICON_THEME_OLD="breeze"
   else
    echo wrong breeze theme $1
    exit
   fi
 fi
 grep "${PATTERN_START}auto" "$CONFIG_FILE"
 if [ $? == 0 ]; then
   sed -i "s#${PATTERN_START}auto#${PATTERN_START}$ICON_THEME_NEW#" "$CONFIG_FILE"
 else
   sed -i "s#>$ICON_THEME_OLD<#>$ICON_THEME_NEW<#" "$CONFIG_FILE"
 fi

else
 echo create libreoffice config $HOME/.config/libreoffice/4/user/registrymodifications.xcu
 if [ ! -d "$CONFIG_PATH" ]; then mkdir -p "$CONFIG_PATH"; fi
 echo "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" > "$CONFIG_FILE"
 echo "<oor:items xmlns:oor=\"http://openoffice.org/2001/registry\" xmlns:xs=\"http://www.w3.org/2001/XMLSchema\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\">" >> "$CONFIG_FILE"
 echo "${PATTERN_START}$1${PATTERN_END}" >> "$CONFIG_FILE"
 echo "$FILE_END" >> "$CONFIG_FILE"
fi
