#!/bin/bash
if [ a"" = a"$1" ]; then echo "No file to print"; exit 1; fi

FILE="$1"
PRINT_CMD=0
OKULAR_CMD="okular --print-and-exit"
LIBRE_CMD="libreoffice --headless -p"
#todo: check path?
#OKULAR_PATH=`which okular`
#LIBRE_PATH=`which libreoffice`

MIMETYPE=`xdg-mime query filetype "$FILE"`
if [ a"" = a"$MIMETYPE" ]; then echo "Can't get mimetype of $FILE"; exit 1; fi

#if it is Link to file then get mime of destination
if [ "$MIMETYPE" = "application/x-desktop" ]; then
  if grep Link "$FILE" > /dev/null; then
    FILE_LNK=`grep URL "$FILE" | cut -d '=' -f 2`
    #remove double quotes if any
    temp="${FILE_LNK%\"}"
    temp="${temp#\"}"
    FILE_LNK=$temp
    MIMETYPE_LNK=`xdg-mime query filetype "$FILE_LNK"`
    if [ a"" != a"$MIMETYPE_LNK" ]; then
      FILE=$FILE_LNK
      MIMETYPE=$MIMETYPE_LNK
    fi
  fi
fi


APPDESKTOP=$(xdg-mime query default $MIMETYPE)

#check libre and okular assignments
if [ "$PRINT_CMD" = 0 ]; then
  if echo $APPDESKTOP | grep libre > /dev/null ;then PRINT_CMD=$LIBRE_CMD; fi
fi
if [ "$PRINT_CMD" = 0 ]; then
  if echo $APPDESKTOP | grep okular > /dev/null ;then PRINT_CMD=$OKULAR_CMD; fi
fi
#if no known assignments then check desktop files
if [ "$PRINT_CMD" = 0 ]; then
  if grep "$MIMETYPE" /usr/share/applications/*okular*.desktop > /dev/null; then PRINT_CMD=$OKULAR_CMD; fi
fi
if [ "$PRINT_CMD" = 0 ]; then
  if grep "$MIMETYPE" /usr/share/applications/*libreoffice*.desktop > /dev/null; then PRINT_CMD=$LIBRE_CMD; fi
fi

#if nothing PRINT_CMD then inform about failure
if [ "$PRINT_CMD" = 0 ]; then
  if [ $LANG = "C" ]; then LANG="ru_RU.UTF-8"; fi
  if [ $LANG != "ru_RU.UTF-8" ]; then
    CAPTION="Print"
    MESSAGE="$FILE (type=$MIMETYPE)\n can't be printed by libreoffice and okular"
  else
    CAPTION="Печать"
    MESSAGE="$FILE (тип=$MIMETYPE)\n нельзя напечатать через libreoffice и okular"
  fi
  fly-dialog --caption "$CAPTION" -icon "printer" --msgbox "$MESSAGE"
  exit 2
else
  $PRINT_CMD "$FILE"
fi

exit 0
